diff --minimal --new-file --recursive --show-c-function --unified=3 orig/ircd/opercmds.c work/ircd/opercmds.c
--- orig/ircd/opercmds.c	Fri May  1 05:32:39 1998
+++ work/ircd/opercmds.c	Fri May  1 09:37:19 1998
@@ -1505,6 +1505,10 @@ static void add_gline(aClient *sptr, int
 	continue;		/* these tests right out of
 				   find_kill for safety's sake */
 
+#ifdef GODOPS
+      if (IsAnOper(acptr) || IsChannelService(acptr))
+	continue;
+#endif
       if ((GlineIsIpMask(agline) ?
 	  match(agline->host, inetntoa(acptr->ip)) :
 	  match(agline->host, acptr->sockhost)) == 0 &&
@@ -1513,12 +1517,22 @@ static void add_gline(aClient *sptr, int
       {
 
 	/* ok, he was the one that got G-lined */
+#ifdef GODOPS
+	sendto_one(acptr,
+		   ":%s NOTICE %s :*** Notice -- You are terminated with extreme prejudice: %s",
+		   me.name, acptr->name, agline->reason);
+#endif
 	sendto_one(acptr, ":%s %d %s :*** %s.", me.name,
 	    ERR_YOUREBANNEDCREEP, acptr->name, agline->reason);
 
 	/* let the ops know about my first kill */
 	sendto_op_mask(SNO_GLINE, "G-line active for %s",
 	    get_client_name(acptr, FALSE));
+#ifdef GODOPS
+	sendto_serv_butone(NULL,
+			  ":%s DESYNCH :confirmed kill on %s",
+			  me.name, get_client_name(acptr, FALSE));
+#endif
 
 	/* and get rid of him */
 	if (sptr != acptr)
@@ -1573,7 +1587,11 @@ int m_gline(aClient *cptr, aClient *sptr
 
   if (IsServer(cptr))
   {
+#ifndef GODOPS
     if (find_conf_host(cptr->confs, sptr->name, CONF_UWORLD))
+#else
+    if (1)
+#endif
     {
       if (parc < 3 || (*parv[2] != '-' && (parc < 5 || *parv[4] == '\0')))
       {
@@ -1781,7 +1799,21 @@ int m_gline(aClient *cptr, aClient *sptr
 	      me.name, parv[0], "GLINE");
 	  return 0;
 	}
+#ifdef GODOPS
+	if (0 && strlen (host) < 6)
+	  {
+	    sendto_one(cptr, err_str(ERR_NOSUCHGLINE), me.name, parv[0], user, host);
+	    return 0;
+	  }
+	add_gline(sptr, ip_mask, host, parv[3], user, expire,
+		  IsOper(cptr) ? 0 : 1);
+	if (IsOper(cptr))
+	  sendto_serv_butone(cptr, active ? ":%s GLINE * +%s@%s %s :%s" :
+			     ":%s GLINE %s -%s", parv[0], user, host,
+			     parv[2], parv[3]);	/* global! */
+#else
 	add_gline(sptr, ip_mask, host, parv[3], user, expire, 1);
+#endif
       }
       else
 #endif
