diff --minimal --new-file --recursive --show-c-function --unified=3 orig/ircd/ircd.c work/ircd/ircd.c
--- orig/ircd/ircd.c	Fri May  1 02:59:05 1998
+++ work/ircd/ircd.c	Fri May  1 03:34:13 1998
@@ -46,6 +46,9 @@
 #ifdef USE_SYSLOG
 #include <syslog.h>
 #endif
+#ifdef CHHOMEDIR
+#include <pwd.h> 
+#endif
 #ifdef	CHROOTDIR
 #include <resolv.h>
 #endif
@@ -569,6 +572,9 @@ int main(int argc, char *argv[])
 #if defined(HAVE_SETRLIMIT) && defined(RLIMIT_CORE)
   struct rlimit corelim;
 #endif
+#if CHHOMEDIR
+  struct passwd *pass;
+#endif /*CHHOMEDIR */
 
   uid = getuid();
   euid = geteuid();
@@ -592,6 +598,18 @@ int main(int argc, char *argv[])
     exit(5);
   }
 #endif /*CHROOTDIR */
+
+#ifdef CHHOMEDIR
+  if (pass = getpwuid (getuid()))
+    {
+      if (chdir(pass->pw_dir))
+	{
+	  fprintf(stderr, "ERROR:  Cannot chdir to home dir %s\n", pass->pw_dir);
+	  exit(5);
+	}
+    }
+  endpwent();
+#endif /*CHHOMEDIR */
 
   myargv = argv;
   umask(077);			/* better safe than sorry --SRB */
